# _*_ coding: utf8 _*_
import time # В этом модуле - задержки
import smbus # В этом модуле - средства для работы с шиной i2c
import kbh # В этом модуле - функция kbhit() для работы с клавиатурой
           # в неблокирующем режиме
#-------------------------------------------------------------------------------
# Тестирование прошивки контроллера ТЭНа
#-------------------------------------------------------------------------------
# 'q' - выход из программы
# Управление контроллером контактора:
# 'w' - включить контактор
# 's' - выключить контактор
# Управление контроллером ТЭНа:
# 'e' - увеличить уровень pdm
# 'd' - уменьшить уровень pdm
# 'r' - pdm - на 100%
# 'f' - pdm - в 0
# Управление контроллером клапана отбора:
# 't' - увеличить pwm на 0.1%
# 'g' - уменьшить pwm на 0.1%
# 'y' - увеличить pwm на 1%
# 'h' - уменьшить pwm на 1%
# 'u' - pwm - на 100%
# 'j' - pwm - в 0
#-------------------------------------------------------------------------------
bus = smbus.SMBus(1) # Создаем объект "шина i2c"
addrC = 0x12 # Адрес контроллера контактора
addrT = 0x13 # Адрес контроллера ТЭНа на шине i2c
addrV = 0x14 # Адрес контроллера клапана отбора на шине i2c
tt = kbh.TT(500) # Создаем объект - терминал, работающий в неблокирующем режиме
                 # timeout = 500 ms
pdm = 0 # Уровень pdm (pulse density modulation, ака Брезенхем)
opdm = 0
pwm = 0 # Уровень ШИМ клапана отбора
opwm = 0
while True:
  if tt.kbhit(): # Была нажата какая-то клавиша
    ch = tt.getch() # Получаем введенный символ
    if ch == 'q': # Выход их программы - выключаем все
      bus.write_byte(addrC, 0) # Выключить контактор
      bus.write_byte(addrT, 0) # Выключить ТЭН
      bus.read_byte(addrV)     # Выключить клапан
      bus.write_byte(addrV, 0) 
      bus.write_byte(addrV, 0)
      break
    elif ch == 'w': bus.write_byte(addrC, 1) # Включим контактор
    elif ch == 's': bus.write_byte(addrC, 0) # Выключим контактор

    elif ch == 'e' or ch == '=': pdm += 1 # Увеличим уровень pdm
    elif ch == 'd' or ch == '-': pdm -= 1 # Уменьшим уровень pdm
    elif ch == 'r': pdm = 100    # Максимальный уровень pdm - 100%
    elif ch == 'f': pdm = 0      # Минимальный уровень pdm - 0%

    elif ch == 't': pwm += 1     # Увеличим уровень pwm на 0.1%
    elif ch == 'g': pwm -= 1     # Уменьшим уровень pwm на 0.1%
    elif ch == 'y': pwm += 10    # Увеличим уровень pwm на 1%
    elif ch == 'h': pwm -= 10    # Уменьшим уровень pwm на 1%
    elif ch == 'u': pwm = 1000   # Максимальный уровень pwm - 100%
    elif ch == 'j': pwm = 0      # Минимальный уровень pwm - 0%

  if pdm > 100: pdm = 100
  if pdm < 0: pdm = 0
  if opdm <> pdm: # Уровень pdm был изменен - покажем его
    bus.write_byte(addrT, pdm)   # Шлем уровень pdm контроллеру ТЭНа
    print 'pdm = ', pdm; opdm = pdm

  if pwm > 1000: pdm = 1000
  if pwm < 0: pwm = 0
  if opwm <> pwm: # Уровень pwm был изменен - пошлем его контроллеру и покажем
    print bus.read_byte(addrV)
    bus.write_byte(addrV, (pwm & 0xff))
    bus.write_byte(addrV, ((pwm >> 8) & 0xff))
    print 'pwm = ', pwm*0.1; opwm = pwm
