# _*_ coding: utf8 _*_
import time # В этом модуле - задержки
import smbus # В этом модуле - средства для работы с шиной i2c
from Tkinter import * # Инструментарий для GUI
import tkMessageBox as mbox # Чтобы ругаться
#-------------------------------------------------------------------------------
# Тестирование firmware контроллера ТЭНа
#-------------------------------------------------------------------------------
addrC = 0x12 # Адрес контроллера контактора
addrT = 0x13 # Адрес контроллера ТЭНа
addrV = 0x14 # Адрес контроллера клапана отбора на шине i2c
#-------------------------------------------------------------------------------
def fC(): # Вызывается при изменении состояния чекбокса
  global vC
  bus.write_byte(addrC, vC.get());
#-------------------------------------------------------------------------------
def fT(): # Вызывается при изменении состояния спинбокса ТЭНа
  global sbT, pdm
  pdm = int(sbT.get())
  bus.write_byte(addrT, pdm);
#-------------------------------------------------------------------------------
def fV(): # Вызывается при изменении состояния спинбокса клапана отбора
  global sbV, pwm
  pwm = int(sbV.get())*10
  if(bus.read_byte(addrV) == 0xff):
    bus.write_byte(addrV, (pwm & 0xff))
    bus.write_byte(addrV, ((pwm >> 8) & 0xff))
  else:mbox.showerror('Ошибка', 'Ошибка контроллера клапана отбора')
#-------------------------------------------------------------------------------
def wclose(): # Перед закрытием главного окна приложения выключим все
  bus.read_byte(addrV)      # Выключить клапан
  bus.write_byte(addrV, 0) 
  bus.write_byte(addrV, 0)
  bus.write_byte(addrT, 0); # Выключаем ТЭН
  bus.write_byte(addrC, 0); # Выключаем контактор
  root.destroy()
#-------------------------------------------------------------------------------
bus = smbus.SMBus(1) # Создаем объект "шина i2c"
root = Tk(); root.geometry('122x62') # Создаем и настраиваем главное окно
root.protocol('WM_DELETE_WINDOW', wclose)
vC = IntVar() # Состояние чекбокса (контактора)
# Создаем объект - чекбокс
chC = Checkbutton(text = 'Контактор', command = fC, variable = vC)
pdm = 0 # Уровень pdm-модуляции для контроллера ТЭНа
lpdm = Label(text = 'ТЭН (%) = ', width = 13, anchor = 'w') # Метка PDM
# Создаем объект - спинбокс
sbT = Spinbox(from_ = 0, to = 100, width = 3, command = fT, justify = RIGHT)
pwm = 0 # Уровень pwm-модуляции для контроллера клапана отбора
lpwm = Label(text = 'Клапан (%) = ', width = 13, anchor = 'w') # Метка ШИМ
# Создаем объект - спинбокс
sbV = Spinbox(from_ = 0, to = 100, width = 3, command = fV, justify = RIGHT)
# Размещаем виджеты в главном окне
chC.place(x = 0, y = 0)
lpdm.place(x = 0, y = 20)
sbT.place(x = 80, y = 20)
lpwm.place(x = 0, y = 40)
sbV.place(x = 80, y = 40)
root.mainloop() # Главный цикл приложения
